part of cresce_ui;

class _CModal extends StatelessWidget {
  final Widget child;
  final Size size;
  final double radius;
  final Gradient? gradient;
  final VoidCallback? onTap;

  const _CModal({
    Key? key,
    required this.child,
    required this.size,
    required this.radius,
    this.gradient,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTapUp: (_) => onTap?.call(),
      child: Container(
        width: size.width,
        height: size.height,
        decoration: BoxDecoration(
          gradient: gradient,
          borderRadius: BorderRadius.circular(radius),
          color: const Color(0xffffffff),
          boxShadow: const [
            BoxShadow(
              color: Color(0x29000000),
              offset: Offset(0, 3),
              blurRadius: 6,
            ),
          ],
        ),
        child: child,
      ),
    );
  }
}

class CBigModal extends StatelessWidget {
  final Widget child;
  final Size size;
  final Gradient? gradient;
  final VoidCallback? onTap;

  const CBigModal({
    Key? key,
    required this.child,
    this.size = const Size(324.0, 500.0),
    this.gradient,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) => _CModal(
        child: child,
        radius: 20.0,
        size: size,
        gradient: gradient,
        onTap: onTap,
      );
}

class CSmallModal extends StatelessWidget {
  final Widget child;
  final Size size;
  final Gradient? gradient;
  final VoidCallback? onTap;

  const CSmallModal({
    Key? key,
    required this.child,
    this.size = const Size(180.0, 243.0),
    this.gradient,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) => _CModal(
        child: child,
        radius: 9.0,
        size: size,
        gradient: gradient,
        onTap: onTap,
      );
}
